<?php
session_start();
$jahrgang = $_SESSION["jahrgang"];
include_once 'classes/TestProjektSmarty.class.php';
require_once("config.inc.php");
$templatename = substr(basename($_SERVER['PHP_SELF']), 0, -3) . "html";
$smarty       = new Smarty();
require_once "functions.php";
require_once "language/german.inc.php";
#require_once "func_lvs_exk_mehrtaegig.php";
#require_once "func_lvs_exk_eintaegig.php";

if (isset($_GET['action'])) {
  $action = $_GET['action'];
} else {
  $action = '';
}


if ($action == '') {
  
  if ($jahrgang == "") {
    echo "Bitte zuerst <a href='jahrgang.php'>Jahrgang</a> w&auml;hlen!";
    exit;
  }
  

  
  if (isset($_GET['edit'])) {
    $_SESSION["abwlehrb_status"] = 'edit';
    $deid                    = $_GET['edit'];
    $_SESSION["abwlehrb_deid"]   = $deid;
  } else {
    $_SESSION["abwlehrb_status"] = 'neu';
  }
  
  # -- Fehlermeldungen -- #
  if (isset($_GET[error])) {
    
    $errorno = $_GET[error];
    
    $smarty->assign('abwlehrb_error', 1);
    
    $smarty->assign('abwlehrb_value_std', $_SESSION["abwlehrb_value_lvs"]);
    $smarty->assign('abwlehrb_value_befristung_bis', $_SESSION["abwlehrb_value_befristung_bis"]);
 
    if ($errorno == 2) {
      # mehrere Abweichende Lehrbedarfe
      $smarty->assign('abwlehrb_error_text', "Es kann nur eine Abweichung eingegeben werden!");
    }
    
    if ($errorno == 3) {
      # ungültiges Datum
      $smarty->assign('abwlehrb_error_text', "Das eingegebene Datum ist nicht korrekt. Bitte korrigieren Sie das Datum!");
    }
    
    $jahrgang2 = $jahrgang+1;
    if ($errorno == 5) {
      $smarty->assign('abwlehrb_error_text', "Das Datum ist außerhalb des Jahrgangs!<br>Datum muss im Bereich 01.09.$jahrgang - 31.08.$jahrgang2 liegen.");
    }
  }  
  
  # --- Wenn Werte editiert werden ------------
  if ($_SESSION["abwlehrb_status"] == 'edit') {
    $result_edit = $db->query("SELECT deid, funktion, date_format(beginn, '%d.%m.%Y') beginn, date_format(ende, '%d.%m.%Y') ende, beantragung
                                 FROM dep_deputat_ermaessigung
                                WHERE deid = $deid");
    $row_edit    = $result_edit->fetch_array();
    $smarty->assign('abwlehrb_value_befristung_bis', "$row_edit[ende]");
    $smarty->assign('abwlehrb_value_std', "$row_edit[beantragung]");
    
  }
  # --- Wenn Werte editiert werden Ende -------
  
  if ($_GET['editende'] == 1) {
    # Editieren ist beendet, als ein update auf einen Datensatz. Dann ist der status wieder Neu, damit wird wieder ein Insert durchgefÃ¼hrt
    $_SESSION["abwlehrb_status"] = 'neu';
  }

    
  # Gespeicherte Werte
  $query2 = "SELECT deid, funktion, date_format(ende, '%d.%m.%Y') ende, beantragung
                 FROM dep_deputat_ermaessigung
                WHERE imtuid=$uid
                  AND jahr=$jahrgang
                  AND art LIKE '%Abweichender Lehrbedarf%'
                ORDER BY deid ASC";
  
  $result2 = $db->query($query2) or die("Cannot execute query2");
  
  while ($row2 = $result2->fetch_array()) {
    $lvs                       = number_format($row2['beantragung'], 2, ',', '.');
    $row2['lvs']               = $lvs;
    $table_data2[]             = $row2;
  }
  $smarty->assign('table_data2', $table_data2);
  
  # Jahressumme
  $query_jahrsum = $db->query("SELECT sum(lvs) summe_jahr
                                   FROM dep_deputat_ermaessigung
                                   WHERE imtuid=$uid
                                     AND art LIKE '%Abweichender Lehrbedarf%'
                                     AND jahr=$jahrgang");
  $row_jahrsum   = $query_jahrsum->fetch_array();
  $summe_jahr    = number_format($row_jahrsum['summe_jahr'], 2, ',', '.');
  $smarty->assign('abwlehrb_value_summe_jahr', $summe_jahr);
  
}


if ($action == 'save') {
$jahrgang2 = $jahrgang+1;

$lvs      = str_replace(',','.',str_replace('.','', $_POST['lvs']));

$ende = preg_replace('/^(\\d{2})\\.(\\d{2})\\.(\\d{4})$/', '$3-$2-$1', $_POST['befristung_bis']);
if($ende == ''){
 $ende = $jahrgang2."-08-31";
}


$_SESSION["abwlehrb_value_befristung_bis"]   = $_POST['befristung_bis'];
$_SESSION["abwlehrb_value_lvs"]               = $lvs;

$query_anz = $db->query("SELECT count(*) Anz
                                FROM dep_deputat_ermaessigung
                               WHERE imtuid=$uid
                                 AND art LIKE '%Abweichender Lehrbedarf%'
                                 AND jahr=$jahrgang");
$row_anz   = $query_anz->fetch_array();
if($row_anz['Anz' > 1] AND $_SESSION["abwlehrb_status"] == 'neu'){
  if($_SESSION["abwlehrb_status"] == 'neu'){
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=" . $_SERVER['PHP_SELF'] . "?error=2\">";
  }else{
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=" . $_SERVER['PHP_SELF'] . "?error=2&edit=$_SESSION[abwlehrb_deid]\">";
  }
  exit;    
}

function validateDate($date, $format = 'Y-m-d')
{
    $d = DateTime::createFromFormat($format, $date);
    return $d && $d->format($format) == $date;
}

if(!validateDate($ende)){
  if($_SESSION["abwlehrb_status"] == 'neu'){
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=" . $_SERVER['PHP_SELF'] . "?error=3\">";
  }else{
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=" . $_SERVER['PHP_SELF'] . "?error=3&edit=$_SESSION[abwlehrb_deid]\">";
  }
  exit;    
}


# Ende ist immer Monatsletzter des angegebenen Monats
#$year_ende = substr($ende,0,4);
#$mon_ende  = substr($ende,5,2);
#$day_ende  = '01';  #substr($ende,8,2); # Hier gibt man monatsersten an, die Funktion Y-m-t macht Monatsende draus
#$save_ende = "$year_ende-$mon_ende-$day_ende";
#$L = new DateTime( $save_ende); 
#$save_ende = $L->format( 'Y-m-t' );

# Datum außerhalb des Jahrgangs 01.09.-31.08
#echo strtotime($save_ende) ." > ". strtotime("$jahrgang2-08-31")."<br>";
#echo strtotime($save_ende) ." < ".  strtotime("$jahrgang-09-01")."<br>";
#exit;
if(strtotime($ende) > strtotime("$jahrgang2-08-31") OR 
   strtotime($ende) < strtotime("$jahrgang-09-01")
  ){
  if($_SESSION["abwlehrb_status"] == 'neu'){
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=" . $_SERVER['PHP_SELF'] . "?error=5\">";
  }else{
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=" . $_SERVER['PHP_SELF'] . "?error=5&edit=$_SESSION[abwlehrb_deid]\">";
  }
  exit;    
}

  $datum = date("Y-m-d H:i:s");
  if ($_SESSION["abwlehrb_status"] == 'neu') {
    $sql1 = $db->query("INSERT INTO dep_deputat_ermaessigung ( imtuid
                                                             , jahr
                                                             , art
                                                             , ende
                                                             , beantragung
                                                             , sort_order
                                                             , created
                                                             )
                                VALUES
                                                             ( '$uid'
                                                             , '$jahrgang'
                                                             , 'Abweichender Lehrbedarf'
                                                             , '$ende'
                                                             , '$lvs'
                                                             , 9
                                                             , '$datum'
                                                             )
                              ");
  }
  
  if ($_SESSION["abwlehrb_status"] == 'edit') {
    $deid   = $_SESSION["abwlehrb_deid"];
    $result = $db->query("UPDATE dep_deputat_ermaessigung 
                                 SET ende  = '$ende'
                                   , beantragung='$lvs'
                                   , modify_date = '$datum'
                              WHERE deid = $deid
                         ");
    
    unset($_SESSION['abwlehrb_deid']);
  }
  # Dann bekommts beim refresh den status neu, also es wird beim Abschicken ein Insert gemacht
  $editende = 1;
  echo "<meta http-equiv=\"refresh\" content=\"0; URL=" . $_SERVER['PHP_SELF'] . "?editende=$editende\">";


}
if ($action == 'del') {
  $deid = $_GET['deid'];
  
  ## Muss man nochmals Ã¼berdenken, wenn ein Prof noch Deputate erfasst hat.
  $del1 = $db->query("DELETE FROM dep_deputat_ermaessigung WHERE deid = $deid AND imtuid=$uid");
  
  echo "<meta http-equiv=\"refresh\" content=\"0; URL=" . $_SERVER['PHP_SELF'] . "\">";
}

$smarty->assign('action', "$action");
$smarty->display("$template/$templatename");

?>